_AUTO_RELOAD_DEBUG = function() print('pattern_overwrite_pone_auto_reloaded') end
class "RenoiseScriptingTool" (renoise.Document.DocumentNode)
  function RenoiseScriptingTool:__init()    
    renoise.Document.DocumentNode.__init(self) 
    self:add_property("Name", "Untitled Tool")
    self:add_property("Id", "Unknown Id")
  end
local manifest = RenoiseScriptingTool()
local ok,err = manifest:load_from("manifest.xml")
local tool_name = manifest:property("Name").value
local tool_id = manifest:property("Id").value

local tll = renoise.tool()
local app = renoise.app()
local onff = false
local sn, tr, el, pt, pa, ov

local function new_pat()
	pa = sn.selected_pattern
end
local function new_pat_track()
	pt = sn.selected_pattern_track
end
local function new_sng()
	if renoise.song then 
		sn = renoise.song()
		tr = sn.transport
		new_pat()
		new_pat_track()
		if sn.selected_pattern_observable:has_notifier(new_pat) then sn.selected_pattern_observable:remove_notifier(new_pat) end
		sn.selected_pattern_observable:add_notifier(new_pat)
		if sn.selected_pattern_track_observable:has_notifier(new_pat_track) then sn.selected_pattern_track_observable:remove_notifier(new_pat_track) end
		sn.selected_pattern_track_observable:add_notifier(new_pat_track)
		onff = false
		if tll:has_timer(ov) then tll:remove_timer(ov) end
	end
end
ov =  function()
    el = sn.selected_line_index +1
    if el > pa.number_of_lines then
		pt:line(1):clear()
		return
	elseif tr.loop_block_enabled and el == tr.loop_end.line then
		pt:line(tr.loop_block_start_pos.line):clear()
		return
	else
		pt:line(el):clear()
	end
end
local function on_off()
  if not sn then new_sng() end
  if not onff then
      onff = true
      tll:add_timer(ov, 5)
      app:show_status('Overwrite ON.')
    else
      onff = false
      tll:remove_timer(ov)
      app:show_status('Overwrite OFF.')
  end
end
tll.app_new_document_observable:add_notifier(new_sng)
local function cpt()
   pt:clear()
   tr:start_at(1)
end
renoise.tool():add_menu_entry {
  name = "Main Menu:Tools:Overwrite On/Off",
  invoke = on_off
}
renoise.tool():add_keybinding {
  name = "Pattern Editor:Tools:Overwrite On/off",
  invoke = on_off
}
renoise.tool():add_midi_mapping {
  name = "Tools:Overwrite_On/off",
  invoke = on_off
}
renoise.tool():add_keybinding {
  name = "Pattern Editor:Tools:Clear pattern track and restart pattern",
  invoke = cpt
}
renoise.tool():add_midi_mapping {
  name = "Tools:Clear pattern track and restart pattern",
  invoke = cpt
}